DROP TABLE IF EXISTS onboarding.after_opening_app_npath;
CREATE TABLE onboarding.after_opening_app_npath
    DISTRIBUTE BY HASH(cmusno) 
    COMPRESS AS (
    SELECT *
    FROM NPATH(
    ON (SELECT *
    FROM onboarding.event_list_18_0_to_90_removed
    WHERE domain_type IN ('acq_chn', 'APPLICATION') or event_desc  IN ('PreAprvdOVD_Apprvd',
'OVD_App_Apprvd',
'DCOpen',
'CCOpen_PRM-OTHR',
'CCOpen_PRM-PLT',
'CCOpen_SUP-OTHR',
'CCOpen_PRM-CTEB',
'CCOpen_SUP-PLT',
'DepositOpening_O/N',
'DepositOpening_TimeDeposit',
'DepositOpening_DemandDeposit',
'AutoPmtOpen_SIGORTA',
'AutoPmtOpen_OTHERS',
'AutoPmtOpen_OFO',
'CarLnOpenYP',
'CarLnOpenTL',
'PerLnOpenTL',
'MtgeOpenYP',
'PerFinLnOpenTL',
'MtgeOpenTL',
'WorkplaceLnOpenTL',
'PerLnOpenYP'
))
    PARTITION BY cmusno
    ORDER BY row_number
    MODE('NONOVERLAPPING')
    SYMBOLS(domain_type IN ('acq_chn') AS a,
    event_desc IN (
    'CarLoan_App_Apprvd',
'CC_App_Apprvd',
'CCLimitChn_App_Apprvd',
'CC-Sup_App_Apprvd',
'MortgageLoan_App_Apprvd',
'OVDLimitChn_App_Apprvd',
'PerLoan_App_Apprvd',
'PreAprovdCC_Apprvd',
'PreAprvdCCLmt_Apprvd',
'PreAprvdOVD_Apprvd',
'PreAprvdOVDLmt_Apprvd',
'PreAprvdPerLoan_Apprvd',
'Unknown_App_Apprvd') AS b,
    event_desc NOT IN (
    'CarLoan_App_Apprvd',
'CC_App_Apprvd',
'CCLimitChn_App_Apprvd',
'CC-Sup_App_Apprvd',
'MortgageLoan_App_Apprvd',
'OVDLimitChn_App_Apprvd',
'PerLoan_App_Apprvd',
'PreAprovdCC_Apprvd',
'PreAprvdCCLmt_Apprvd',
'PreAprvdOVD_Apprvd',
'PreAprvdOVDLmt_Apprvd',
'PreAprvdPerLoan_Apprvd',
'Unknown_App_Apprvd') AS c,
    event_desc IN (
    'CarLoan_App',
'CC_App',
'CCLimitChn_App',
'CC-Sup_App',
'MortgageLoan_App',
'OVD_App',
'OVDLimitChn_App',
'PerLoan_App',
'Unknown_App') AS d,
    event_desc NOT IN (
    'CarLoan_App',
'CC_App',
'CCLimitChn_App',
'CC-Sup_App',
'MortgageLoan_App',
'OVD_App',
'OVDLimitChn_App',
'PerLoan_App',
'Unknown_App') AS e,
 event_desc  IN ('PreAprvdOVD_Apprvd',
'OVD_App_Apprvd',
'DCOpen',
'CCOpen_PRM-OTHR',
'CCOpen_PRM-PLT',
'CCOpen_SUP-OTHR',
'CCOpen_PRM-CTEB',
'CCOpen_SUP-PLT',
'DepositOpening_O/N',
'DepositOpening_TimeDeposit',
'DepositOpening_DemandDeposit',
'AutoPmtOpen_SIGORTA',
'AutoPmtOpen_OTHERS',
'AutoPmtOpen_OFO',
'CarLnOpenYP',
'CarLnOpenTL',
'PerLnOpenTL',
'MtgeOpenYP',
'PerFinLnOpenTL',
'MtgeOpenTL',
'WorkplaceLnOpenTL',
'PerLnOpenYP'
) as f,
true as o
    )
    PATTERN('a.f.d?.o?')  -- Get all the customers where there is one application approval and customers are going for another application
    RESULT(ACCUMULATE(event_desc OF ANY(a,d,f,o)) AS path,
    FIRST(cmusno OF a) AS cmusno,
    COUNT(cmusno OF ANY(a,d,f,o)) AS lenPath,
    FIRST(event_date OF a) AS start_date,
    LAST(event_date OF ANY(o)) AS end_date)
    )
    );
GRANT ALL ON onboarding.after_opening_app_npath TO db_analytics;

--Accumulate paths
DROP TABLE IF EXISTS onboarding.freq_after_opening_app_npath;
CREATE TABLE onboarding.freq_after_opening_app_npath
    DISTRIBUTE BY HASH(path)
    COMPRESS AS (
    SELECT path, CAST(avg( CAST (end_date AS DATE) - CAST (start_date AS DATE) ) AS INTEGER) duration, lenPath, count(*) cnt
    FROM onboarding.after_opening_app_npath
    WHERE lenPath >= 2
    GROUP BY 1, lenPath
    );
GRANT ALL ON onboarding.freq_after_opening_app_npath TO db_analytics;